Search Results for

Show / Hide Table of Contents

# Class Window

A Toplevel View that draws a border around its Frame with a Title at the top.

##### Inheritance

System.Object
Responder
View
Toplevel
Window
Dialog

##### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize

##### Remarks

The 'client area' of a Window is a rectangle deflated by one or more rows/columns from Bounds. A this time there is no API to determine this rectangle.

##### Inherited Members

Toplevel.OnLoaded()
Toplevel.OnAlternateForwardKeyChanged(Key)
Toplevel.OnAlternateBackwardKeyChanged(Key)
Toplevel.OnQuitKeyChanged(Key)
Toplevel.Create()
Toplevel.OnKeyDown(KeyEvent)
Toplevel.OnKeyUp(KeyEvent)
Toplevel.ProcessKey(KeyEvent)
Toplevel.ProcessColdKey(KeyEvent)
Toplevel.PositionToplevel(Toplevel)
Toplevel.MouseEvent(MouseEvent)
Toplevel.WillPresent()
Toplevel.MoveNext()
Toplevel.MovePrevious()
Toplevel.RequestStop()
Toplevel.RequestStop(Toplevel)
Toplevel.PositionCursor()
Toplevel.GetTopMdiChild(Type, String[])
Toplevel.ShowChild(Toplevel)
Toplevel.Running
Toplevel.CanFocus
Toplevel.Modal
Toplevel.MenuBar
Toplevel.StatusBar
Toplevel.IsMdiContainer
Toplevel.IsMdiChild
Toplevel.Loaded
Toplevel.Ready
Toplevel.Unloaded
Toplevel.Activate
Toplevel.Deactivate
Toplevel.ChildClosed
Toplevel.AllChildClosed
Toplevel.Closing
Toplevel.Closed
Toplevel.ChildLoaded
Toplevel.ChildUnloaded
Toplevel.Resized
Toplevel.AlternateForwardKeyChanged
Toplevel.AlternateBackwardKeyChanged
Toplevel.QuitKeyChanged
View.GetMinWidthHeight(Size)
View.SetMinWidthHeight()
View.UpdateTextFormatterText()
View.ProcessResizeView()
View.SetNeedsDisplay()
View.ClearLayoutNeeded()
View.SetNeedsDisplay(Rect)
View.SetChildNeedsDisplay()
View.Add(View[])
View.BringSubviewToFront(View)
View.SendSubviewToBack(View)
View.SendSubviewBackwards(View)
View.BringSubviewForward(View)
View.Clear()
View.Clear(Rect)
View.ScreenToView(Int32, Int32)
View.ClipToBounds()
View.SetClip(Rect)
View.DrawFrame(Rect, Int32, Boolean)
View.DrawHotString(ustring, Attribute, Attribute)
View.DrawHotString(ustring, Boolean, ColorScheme)
View.Move(Int32, Int32, Boolean)
View.OnAdded(View)
View.OnRemoved(View)
View.OnEnter(View)
View.OnLeave(View)
View.AddRune(Int32, Int32, Rune)
View.ClearNeedsDisplay()
View.OnDrawContent(Rect)
View.OnDrawContentComplete(Rect)
View.SetFocus()
View.InvokeKeybindings(KeyEvent)
View.AddKeyBinding(Key, Command)
View.ReplaceKeyBinding(Key, Key)
View.ContainsKeyBinding(Key)
View.ClearKeybindings()
View.ClearKeybinding(Key)
View.ClearKeybinding(Command)
View.AddCommand(Command, Func<Nullable<Boolean>>)
View.GetSupportedCommands()
View.GetKeyFromCommand(Command)
View.ProcessHotKey(KeyEvent)
View.EnsureFocus()
View.FocusFirst()
View.FocusLast()
View.FocusPrev()
View.FocusNext()
View.LayoutSubviews()
View.ToString()
View.GetAutoSize()
View.GetHotKeySpecifierLength(Boolean)
View.GetTextFormatterBoundsSize()
View.GetBoundsTextFormatterSize()
View.OnMouseEnter(MouseEvent)
View.OnMouseLeave(MouseEvent)
View.OnMouseEvent(MouseEvent)
View.OnMouseClick(View.MouseEventArgs)
View.OnEnabledChanged()
View.OnVisibleChanged()
View.Dispose(Boolean)
View.BeginInit()
View.EndInit()
View.SetWidth(Int32, Int32)
View.SetHeight(Int32, Int32)
View.GetCurrentWidth(Int32)
View.GetCurrentHeight(Int32)
View.GetNormalColor()
View.GetTopSuperView()
View.HotKey
View.HotKeySpecifier
View.Shortcut
View.ShortcutTag
View.ShortcutAction
View.Data
View.Driver
View.Subviews
View.TabIndexes
View.TabIndex
View.TabStop
View.Id
View.IsCurrentTop
View.WantMousePositionReports
View.WantContinuousButtonPressed
View.Frame
View.LayoutStyle
View.Bounds
View.X
View.Y
View.Width
View.Height
View.ForceValidatePosDim
View.TextFormatter
View.SuperView
View.HasFocus
View.Focused
View.MostFocused
View.ColorScheme
View.AutoSize
View.PreserveTrailingSpaces
View.VerticalTextAlignment
View.TextDirection
View.IsInitialized
View.IsAdded
View.Enabled
View.Visible
View.Added
View.Removed
View.Enter
View.Leave
View.MouseEnter
View.MouseLeave
View.MouseClick
View.CanFocusChanged
View.EnabledChanged
View.VisibleChanged
View.HotKeyChanged
View.DrawContent
View.DrawContentComplete
View.KeyPress
View.KeyDown
View.KeyUp
View.LayoutStarted
View.LayoutComplete
View.Initialized
Responder.Dispose()

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class Window : Toplevel

### Constructors

#### Window()

Initializes a new instance of the Window class using Computed positioning.

##### Declaration

    public Window()

#### Window(ustring)

Initializes a new instance of the Window class with an optional title using Computed positioning.

##### Declaration

    public Window(ustring title = null)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | title | Title.

#### Window(ustring, Int32, Border)

Initializes a new instance of the Window using Computed positioning, and an optional title.

##### Declaration

    public Window(ustring title = null, int padding = 0, Border border = null)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | title | Title.
System.Int32 | padding | Number of characters to use for padding of the drawn frame.
Border | border | The Border.

#### Window(Rect, ustring)

Initializes a new instance of the Window class with an optional title using Absolute positioning.

##### Declaration

    public Window(Rect frame, ustring title = null)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | frame | Superview-relative rectangle specifying the location and size
NStack.ustring | title | Title

#### Window(Rect, ustring, Int32, Border)

Initializes a new instance of the Window using Absolute positioning with the specified frame for its location, with the specified frame padding, and an optional title.

##### Declaration

    public Window(Rect frame, ustring title = null, int padding = 0, Border border = null)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | frame | Superview-relative rectangle specifying the location and size
NStack.ustring | title | Title
System.Int32 | padding | Number of characters to use for padding of the drawn frame.
Border | border | The Border.

### Properties

#### Border

##### Declaration

    public override Border Border { get; set; }

##### Property Value

Type | Description
--- | ---
Border |

##### Overrides

View.Border

#### Text

The text displayed by the Label.

##### Declaration

    public override ustring Text { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring |

##### Overrides

View.Text

#### TextAlignment

Controls the text-alignment property of the label, changing it will redisplay the Label.

##### Declaration

    public override TextAlignment TextAlignment { get; set; }

##### Property Value

Type | Description
--- | ---
TextAlignment | The text alignment.

##### Overrides

View.TextAlignment

#### Title

The title to be displayed for this window.

##### Declaration

    public ustring Title { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring | The title

### Methods

#### Add(View)

Adds a subview (child) to this view.

##### Declaration

    public override void Add(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

##### Overrides

Toplevel.Add(View)

#### OnCanFocusChanged()

Method invoked when the CanFocus property from a view is changed.

##### Declaration

    public override void OnCanFocusChanged()

##### Overrides

View.OnCanFocusChanged()

#### OnTitleChanged(ustring, ustring)

Called when the Title has been changed. Invokes the TitleChanged event.

##### Declaration

    public virtual void OnTitleChanged(ustring oldTitle, ustring newTitle)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | oldTitle | The Title that is/has been replaced.
NStack.ustring | newTitle | The new Title to be replaced.

#### OnTitleChanging(ustring, ustring)

Called before the Title changes. Invokes the TitleChanging event, which can be cancelled.

##### Declaration

    public virtual bool OnTitleChanging(ustring oldTitle, ustring newTitle)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | oldTitle | The Title that is/has been replaced.
NStack.ustring | newTitle | The new Title to be replaced.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` if an event handler cancelled the Title change.

#### Redraw(Rect)

Redraws this view and its subviews; only redraws the views that have been flagged for a re-display.

##### Declaration

    public override void Redraw(Rect bounds)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds | The bounds (view-relative region) to redraw.

##### Overrides

Toplevel.Redraw(Rect)

#### Remove(View)

Removes a subview added via Add(View) or Add(View[]) from this View.

##### Declaration

    public override void Remove(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

##### Overrides

Toplevel.Remove(View)

#### RemoveAll()

Removes all subviews (children) added via Add(View) or Add(View[]) from this View.

##### Declaration

    public override void RemoveAll()

##### Overrides

Toplevel.RemoveAll()

### Events

#### TitleChanged

Event fired after the Title has been changed.

##### Declaration

    public event Action<Window.TitleEventArgs> TitleChanged

##### Event Type

Type | Description
--- | ---
System.Action<Window.TitleEventArgs> |

#### TitleChanging

Event fired when the Title is changing. Set Cancel to `true` to cancel the Title change.

##### Declaration

    public event Action<Window.TitleEventArgs> TitleChanging

##### Event Type

Type | Description
--- | ---
System.Action<Window.TitleEventArgs> |

### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize